import os
import re
import subprocess
from os import listdir, path
from os.path import isfile, join

ref_lang = '英文'

video_dir = path.abspath(os.getcwd())


def build_sub_file_name(ori_name: str, target_prefix: str) -> str:
    lang_keywords = ['chs', 'chn', 'eng', 'en', 'zh', '简体', '繁体', '英文']
    sub_segs = ori_name.split('.')
    sub_file_name = ''
    if len(sub_segs) > 2:
        for keyword in lang_keywords:
            if keyword in sub_segs[-2]:
                sub_file_name = '.'.join([target_prefix, sub_segs[-2], sub_segs[-1]])
                break
    if not sub_file_name:
        sub_file_name = '.'.join([target_prefix, sub_segs[-1]])
    return sub_file_name


files = [f for f in listdir(video_dir) if isfile(join(video_dir, f))]
# list the video files
video_files = [f for f in files if f.endswith('mkv') or f.endswith('mp4')]
# list the subtitles
sub_files = [f for f in files if f.endswith('ass') or f.endswith('srt')]

for vid_file in video_files:
    ref_sub = ''
    sub_file_dict = dict()
    episode_str_grp = re.search('([s|S]\\d\\d[e|E]\\d\\d)', vid_file)
    if episode_str_grp:
        episode_str_upper = episode_str_grp.group(1)
        for sub_file in sub_files:
            if episode_str_upper.upper() in sub_file.upper():
                filename, file_extension = path.splitext(vid_file)
                sub_file_name_seg = sub_file.split('.')
                if ref_lang in sub_file_name_seg:
                    ref_new_sub_name = build_sub_file_name(sub_file, filename)
                    ref_sub = (sub_file, ref_new_sub_name)
                    continue
                new_sub_file_name = build_sub_file_name(sub_file, filename)
                sub_file_dict[sub_file] = new_sub_file_name
    if ref_sub:
        cmd_line = ['subsync',
                    f'{join(video_dir, vid_file)}',
                    '-i',
                    f'{join(video_dir, ref_sub[0])}',
                    '-o',
                    f'{join(video_dir, ref_sub[1])}']
        print(f'Exec: {" ".join(cmd_line)}')
        subprocess.run(cmd_line)
    if path.exists(join(video_dir, ref_sub[1])):
        for key, value in sub_file_dict.items():
            cmd_line = ['subsync',
                        f'{join(video_dir, ref_sub[1])}',
                        '-i',
                        f'{join(video_dir, key)}',
                        '-o',
                        f'{join(video_dir, value)}']
            print(f'Exec: {" ".join(cmd_line)}')
            subprocess.run(cmd_line)
